<h1>Workers</h1>

<h2>Live workers</h2>

<div class="search-params">
  <mat-form-field>
    <mat-select
      class="status-select"
      placeholder="Status"
      [(ngModel)]="selectedStatus"
      (selectionChange)="updateSearch()"
      multiple
    >
      <mat-option
        *ngFor="let state of status"
        [value]="state.id"
        [ngClass]="state.id"
        class="state-option"
      >
        {{ state.label }}
      </mat-option>
    </mat-select>
  </mat-form-field>
</div>

<ul class="workers">
  <li class="worker header">
    <span class="instance_id"> Instance ID </span>
    <span class="ips"> IPs </span>
    <span class="ports"> Ports </span>
    <span class="dm_queue_name"> Direct messaging queue name </span>
    <span class="creation_date"> Creation date </span>
    <span class="termination_date"> Termination Date </span>
  </li>
  <li *ngFor="let worker of workers" class="worker">
    <span class="instance_id">
      {{ worker.instance_id }}
    </span>
    <span class="ips">
      <span class="ip" *ngFor="let ip of worker.ips">
        {{ ip }}
      </span>
    </span>
    <span class="ports">
      <span class="port" *ngFor="let port of worker.ports">
        {{ port }}
      </span>
    </span>
    <span class="dm_queue_name">
      {{ worker.direct_messaging_queue_name }}
    </span>
    <span class="creation_date">
      {{ worker.creation_date | date : 'd LLLL yy HH:mm:ss' }}
    </span>
    <span class="termination_date">
      {{ worker.termination_date | date : 'd LLLL yy HH:mm:ss' }}
    </span>
  </li>
</ul>

<h2>Workers status</h2>

<ul class="workers-status">
  <li class="worker header">
    <span class="instance_id"> Instance ID </span>
    <span class="worker-name"> Name </span>
    <span class="worker-version"> Version </span>
    <span class="worker-queue"> Queue </span>
    <span class="worker-activity"> Worker activity </span>
    <span class="current-job"> Current job </span>
    <span class="job-status"> Job status </span>
    <span class="job-duration"> Job duration </span>
    <span class="worker-status-last-update"> Last status update </span>
    <span class="worker-orders"> Orders </span>
  </li>
  <li
    *ngFor="let status of workers_status"
    class="worker worker-status {{ getUpdateStatusClass(status) }}"
  >
    <span class="instance_id">
      {{ status.instance_id }}
    </span>
    <span class="worker-name">
      {{ status.label }}
    </span>
    <span class="worker-version">
      {{ status.version }}
    </span>
    <span class="worker-queue">
      {{ status.queue_name }}
    </span>
    <span
      class="worker-activity"
      *ngIf="!isWorkerStatusOutdated(status) || status.activity == 'Terminated'"
    >
      {{ status.activity }}
    </span>
    <span
      class="worker-activity"
      *ngIf="isWorkerStatusOutdated(status) && status.activity != 'Terminated'"
    >
      {{ status.activity }} (Outdated)
    </span>
    <span
      class="current-job outdated"
      *ngIf="status.current_job && status.activity == 'Terminated'"
    >
      <button
        mat-button
        color="primary"
        (click)="goToWorkflow(status.current_job.job_id)"
        title="Go to workflow"
      >
        {{ status.current_job.job_id }}
      </button>
    </span>
    <span
      class="current-job"
      *ngIf="status.current_job && status.activity != 'Terminated'"
    >
      <button
        mat-button
        color="primary"
        (click)="goToWorkflow(status.current_job.job_id)"
        title="Go to workflow"
      >
        {{ status.current_job.job_id }}
      </button>
    </span>
    <span class="current-job" *ngIf="!status.current_job">
      <button mat-button disabled>-</button>
    </span>
    <span
      class="job-status outdated"
      *ngIf="status.current_job && status.activity == 'Terminated'"
    >
      {{ status.current_job.status }}
    </span>
    <span
      class="job-status"
      *ngIf="status.current_job && status.activity != 'Terminated'"
    >
      {{ status.current_job.status }}
    </span>
    <span class="job-status" *ngIf="!status.current_job"> - </span>
    <span
      class="job-duration"
      *ngIf="status.current_job"
      title="{{ status.current_job.execution_duration }}"
    >
      {{
        status.current_job.execution_duration * 1000 | duration : 'timecode_ms'
      }}
    </span>
    <span class="job-duration" *ngIf="!status.current_job"> - </span>
    <span class="worker-status-last-update">
      {{ status.updated_at | date : 'yyyy-MM-dd HH:mm:ss' }}
    </span>
    <span class="worker-orders" *ngIf="!isWorkerStatusOutdated(status)">
      <button
        mat-raised-button
        color="accent"
        [disabled]="
          !status.current_job ||
          status.current_job.status != 'running' ||
          status.activity == 'Terminated'
        "
        (click)="stopProcess(status.instance_id, status.current_job.job_id)"
        title="Stop process"
      >
        <mat-icon>stop</mat-icon>
      </button>
      <button
        *ngIf="status.activity != 'Suspended'"
        mat-raised-button
        color="primary"
        [disabled]="status.activity == 'Terminated'"
        (click)="toggleJobConsumption(status.instance_id, 'stop')"
        title="Stop consuming jobs"
      >
        <mat-icon>lock</mat-icon>
      </button>
      <button
        *ngIf="status.activity == 'Suspended'"
        mat-raised-button
        color="accent"
        (click)="toggleJobConsumption(status.instance_id, 'resume')"
        title="Resume consuming jobs"
      >
        <mat-icon>lock_open</mat-icon>
      </button>
      <button
        mat-raised-button
        color="warn"
        [disabled]="status.activity == 'Terminated'"
        (click)="stopWorker(status.instance_id)"
        title="Stop worker"
      >
        <mat-icon>cancel</mat-icon>
      </button>
    </span>
    <span class="worker-orders" *ngIf="isWorkerStatusOutdated(status)">
      <button
        mat-stroked-button
        color="accent"
        [disabled]="
          !status.current_job ||
          status.current_job.status != 'running' ||
          status.activity == 'Terminated'
        "
        (click)="stopProcess(status.instance_id, status.current_job.job_id)"
        title="Stop process"
      >
        <mat-icon>stop</mat-icon>
      </button>
      <button
        *ngIf="status.activity != 'Suspended'"
        mat-stroked-button
        color="primary"
        [disabled]="status.activity == 'Terminated'"
        (click)="toggleJobConsumption(status.instance_id, 'stop')"
        title="Stop consuming jobs"
      >
        <mat-icon>lock</mat-icon>
      </button>
      <button
        *ngIf="status.activity == 'Suspended'"
        mat-stroked-button
        color="accent"
        (click)="toggleJobConsumption(status.instance_id, 'resume')"
        title="Resume consuming jobs"
      >
        <mat-icon>lock_open</mat-icon>
      </button>
      <button
        mat-stroked-button
        color="warn"
        [disabled]="status.activity == 'Terminated'"
        (click)="stopWorker(status.instance_id)"
        title="Stop worker"
      >
        <mat-icon>cancel</mat-icon>
      </button>
    </span>
  </li>
</ul>

<mat-paginator
  class="paginator"
  showFirstLastButtons="true"
  [length]="length"
  [pageSize]="pageSize"
  [pageIndex]="page"
  [pageSizeOptions]="pageSizeOptions"
  (page)="pageEvent = changeWorkerStatusPage($event)"
  *ngIf="workers_status && !loading"
>
</mat-paginator>
